require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_PPU_INTRINSICS_H)) {
    eval 'sub _PPU_INTRINSICS_H () {1;}' unless defined(&_PPU_INTRINSICS_H);
    if(!defined(&__PPU__)  && !defined(&__ppc__)  && !defined(&__ppc64__)  && !defined(&__GNUC__)) {
	die("ppu_intrinsics\.h\ included\ on\ wrong\ platform\/compiler");
    }
    if(defined(&__cplusplus)) {
    }
    eval 'sub __cntlzw {
        my($v) = @_;
	    eval q( &__builtin_clz($v));
    }' unless defined(&__cntlzw);
    eval 'sub __cntlzd {
        my($v) = @_;
	    eval q( &__builtin_clzll($v));
    }' unless defined(&__cntlzd);
    eval 'sub __mulhw {
        my($a,$b) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__mulhw);
    eval 'sub __mulhwu {
        my($a,$b) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__mulhwu);
    if(defined(&__powerpc64__)) {
	eval 'sub __mulhd {
	    my($a,$b) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__mulhd);
	eval 'sub __mulhdu {
	    my($a,$b) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__mulhdu);
    }
    eval 'sub __sync () {
        eval q(\\"(assembly code)\\");
    }' unless defined(&__sync);
    eval 'sub __isync () {
        eval q(\\"(assembly code)\\");
    }' unless defined(&__isync);
    eval 'sub __lwsync () {
        eval q(\\"(assembly code)\\");
    }' unless defined(&__lwsync);
    eval 'sub __eieio () {
        eval q(\\"(assembly code)\\");
    }' unless defined(&__eieio);
    eval 'sub __nop () {
        eval q(\\"(assembly code)\\");
    }' unless defined(&__nop);
    eval 'sub __cctpl () {
        eval q(\\"(assembly code)\\");
    }' unless defined(&__cctpl);
    eval 'sub __cctpm () {
        eval q(\\"(assembly code)\\");
    }' unless defined(&__cctpm);
    eval 'sub __cctph () {
        eval q(\\"(assembly code)\\");
    }' unless defined(&__cctph);
    eval 'sub __db8cyc () {
        eval q(\\"(assembly code)\\");
    }' unless defined(&__db8cyc);
    eval 'sub __db10cyc () {
        eval q(\\"(assembly code)\\");
    }' unless defined(&__db10cyc);
    eval 'sub __db12cyc () {
        eval q(\\"(assembly code)\\");
    }' unless defined(&__db12cyc);
    eval 'sub __db16cyc () {
        eval q(\\"(assembly code)\\");
    }' unless defined(&__db16cyc);
    if(defined(&__powerpc64__)) {
	eval 'sub __mtspr {
	    my($spr, $value) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__mtspr);
	eval 'sub __mfspr {
	    my($spr) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__mfspr);
    }
    if(defined(&__powerpc64__)) {
	eval 'sub __mftb () {
	    eval q(\\"(assembly code)\\");
	}' unless defined(&__mftb);
    } else {
	eval 'sub __mftb () {
	    eval q(\\"(assembly code)\\");
	}' unless defined(&__mftb);
    }
    eval 'sub __dcbf {
        my($base) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__dcbf);
    eval 'sub __dcbz {
        my($base) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__dcbz);
    eval 'sub __dcbst {
        my($base) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__dcbst);
    eval 'sub __dcbtst {
        my($base) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__dcbtst);
    eval 'sub __dcbt {
        my($base) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__dcbt);
    eval 'sub __icbi {
        my($base) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__icbi);
    eval 'sub __dcbt_TH1000 {
        my($EATRUNC, $D, $UG, $ID) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__dcbt_TH1000);
    eval 'sub __dcbt_TH1010 {
        my($GO, $S, $UNITCNT, $T, $U, $ID) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__dcbt_TH1010);
    eval 'sub __protected_unlimited_stream_set {
        my($DIRECTION, $ADDR, $ID) = @_;
	    eval q( &__dcbt_TH1000 (($ADDR), ($DIRECTION)>>1, 1, ($ID)));
    }' unless defined(&__protected_unlimited_stream_set);
    eval 'sub __protected_stream_set {
        my($DIRECTION, $ADDR, $ID) = @_;
	    eval q( &__dcbt_TH1000 (($ADDR), ($DIRECTION)>>1, 0, ($ID)));
    }' unless defined(&__protected_stream_set);
    eval 'sub __protected_stream_stop_all () {
        eval q( &__dcbt_TH1010 (0, 3, 0, 0, 0, 0));
    }' unless defined(&__protected_stream_stop_all);
    eval 'sub __protected_stream_stop {
        my($ID) = @_;
	    eval q( &__dcbt_TH1010 (0, 2, 0, 0, 0, ($ID)));
    }' unless defined(&__protected_stream_stop);
    eval 'sub __protected_stream_count {
        my($COUNT, $ID) = @_;
	    eval q( &__dcbt_TH1010 (0, 0, ($COUNT), 0, 0, ($ID)));
    }' unless defined(&__protected_stream_count);
    eval 'sub __protected_stream_go () {
        eval q( &__dcbt_TH1010 (1, 0, 0, 0, 0, 0));
    }' unless defined(&__protected_stream_go);
    eval 'sub __lhbrx {
        my($base) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__lhbrx);
    eval 'sub __lwbrx {
        my($base) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__lwbrx);
    if(defined(&__powerpc64__)) {
	eval 'sub __ldbrx {
	    my($base) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__ldbrx);
    } else {
	eval 'sub __ldbrx {
	    my($base) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__ldbrx);
    }
    eval 'sub __sthbrx {
        my($base, $value) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__sthbrx);
    eval 'sub __stwbrx {
        my($base, $value) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__stwbrx);
    if(defined(&__powerpc64__)) {
	eval 'sub __stdbrx {
	    my($base, $value) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__stdbrx);
    } else {
	eval 'sub __stdbrx {
	    my($base, $value) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__stdbrx);
    }
    eval 'sub __lwarx {
        my($base) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__lwarx);
    if(defined(&__powerpc64__)) {
	eval 'sub __ldarx {
	    my($base) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__ldarx);
    }
    eval 'sub __stwcx {
        my($base, $value) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__stwcx);
    if(defined(&__powerpc64__)) {
	eval 'sub __stdcx {
	    my($base, $value) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__stdcx);
    }
    eval 'sub __mffs () {
        eval q(\\"(assembly code)\\");
    }' unless defined(&__mffs);
    eval 'sub __mtfsf {
        my($mask,$value) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__mtfsf);
    eval 'sub __mtfsfi {
        my($bits,$field) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__mtfsfi);
    eval 'sub __mtfsb0 {
        my($bit) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__mtfsb0);
    eval 'sub __mtfsb1 {
        my($bit) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__mtfsb1);
    eval 'sub __setflm {
        my($v) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__setflm);
    eval 'sub __fabs () { &__ppu_fabs;}' unless defined(&__fabs);
    eval 'sub __fabsf () { &__ppu_fabsf;}' unless defined(&__fabsf);
    eval 'sub __fabs {
        my($x) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__fabs);
    eval 'sub __fabsf {
        my($x) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__fabsf);
    eval 'sub __fnabs {
        my($x) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__fnabs);
    eval 'sub __fnabsf {
        my($x) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__fnabsf);
    eval 'sub __frsqrte {
        my($x) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__frsqrte);
    eval 'sub __fres {
        my($x) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__fres);
    eval 'sub __fsqrt {
        my($x) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__fsqrt);
    eval 'sub __fsqrts {
        my($x) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__fsqrts);
    eval 'sub __fmul {
        my($a,$b) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__fmul);
    eval 'sub __fmuls {
        my($a,$b) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__fmuls);
    eval 'sub __frsp {
        my($a) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__frsp);
    eval 'sub __fcfid {
        my($a) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__fcfid);
    eval 'sub __fctid {
        my($a) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__fctid);
    eval 'sub __fctidz {
        my($a) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__fctidz);
    eval 'sub __fctiw {
        my($a) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__fctiw);
    eval 'sub __fctiwz {
        my($a) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__fctiwz);
    if(defined(&__powerpc64__)) {
	eval 'sub __rldcl {
	    my($a,$b,$mb) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__rldcl);
	eval 'sub __rldcr {
	    my($a,$b,$me) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__rldcr);
	eval 'sub __rldic {
	    my($a,$sh,$mb) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__rldic);
	eval 'sub __rldicl {
	    my($a,$sh,$mb) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__rldicl);
	eval 'sub __rldicr {
	    my($a,$sh,$me) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__rldicr);
	eval 'sub __rldimi {
	    my($a,$b,$sh,$mb) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__rldimi);
    }
    eval 'sub __rlwimi {
        my($a,$b,$sh,$mb,$me) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__rlwimi);
    eval 'sub __rlwinm {
        my($a,$sh,$mb,$me) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__rlwinm);
    eval 'sub __rlwnm {
        my($a,$b,$mb,$me) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__rlwnm);
    if(defined(&__cplusplus)) {
    }
}
1;
