require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_POWERPC_SPR_H_)) {
    eval 'sub _POWERPC_SPR_H_ () {1;}' unless defined(&_POWERPC_SPR_H_);
    if(!defined(&_LOCORE)  && defined(&_KERNEL)) {
	if(defined(&_KERNEL_OPT)) {
	    require './powerpc/opt_ppcarch.ph';
	}
	require 'powerpc/oea/cpufeat.ph';
	if(defined(&PPC_OEA64_BRIDGE) || defined (&_ARCH_PPC64)) {
	    eval 'sub mfspr64 {
	        my($reg) = @_;
    		eval q({  &uint64_t  &ret;  &register_t  &hi,  &l;  &__asm  &volatile( \\"mfspr %0,%2;\\" \\"srdi %1,%0,32;\\" : \\"=r\\"( &l), \\"=r\\"( &hi) : \\"K\\"($reg));  &ret = (( &uint64_t) &hi << 32) |  &l;  &ret; });
	    }' unless defined(&mfspr64);
	    eval 'sub mtspr64 {
	        my($reg, $v) = @_;
    		eval q(( {  &volatile  &register_t  &hi,  &l;  &uint64_t  &val = $v;  &hi = ( &val >> 32);  &l =  &val & 0xffffffff;  &__asm  &volatile( \\"sldi %2,%2,32;\\" \\"or %2,%2,%1;\\" \\"sync;\\" \\"mtspr %0,%2;\\" \\"mfspr %2,%0;\\" \\"mfspr %2,%0;\\" \\"mfspr %2,%0;\\" \\"mfspr %2,%0;\\" \\"mfspr %2,%0;\\" \\"mfspr %2,%0;\\" : : \\"K\\"($reg), \\"r\\"( &l), \\"r\\"( &hi)); } ));
	    }' unless defined(&mtspr64);
	}
	eval 'sub mfspr32 {
	    my($reg) = @_;
    	    eval q({  &register_t  &val;  &__asm  &volatile(\\"mfspr %0,%1\\" : \\"=r\\"( &val) : \\"K\\"($reg));  &val; });
	}' unless defined(&mfspr32);
	eval 'sub mtspr32 {
	    my($reg,$val) = @_;
    	    eval q({  &__asm  &volatile(\\"mtspr %0,%1\\" : : \\"K\\"($reg), \\"r\\"($val)); });
	}' unless defined(&mtspr32);
	if((defined(&PPC_OEA) + defined(&PPC_OEA64) + defined(&PPC_OEA64_BRIDGE)) > 1) {
	    eval 'sub mfspr {
	        my($reg) = @_;
    		eval q({  &if (( &oeacpufeat & ( &OEACPU_64_BRIDGE| &OEACPU_64)) != 0)  &mfspr64($reg);  &mfspr32($reg); });
	    }' unless defined(&mfspr);
	    eval 'sub mtspr {
	        my($reg, $val) = @_;
    		eval q(( {  &if (( &oeacpufeat & ( &OEACPU_64_BRIDGE| &OEACPU_64)) != 0)  &mtspr64($reg, ( &uint64_t)$val);  &else  &mtspr32($reg, $val); } ));
	    }' unless defined(&mtspr);
	} else {
	    if(defined(&PPC_OEA64) || defined(&PPC_OEA64_BRIDGE)) {
		eval 'sub mfspr {
		    my($r) = @_;
    		    eval q( &mfspr64($r));
		}' unless defined(&mfspr);
		eval 'sub mtspr {
		    my($r,$v) = @_;
    		    eval q( &mtspr64($r,$v));
		}' unless defined(&mtspr);
	    } else {
		eval 'sub mfspr {
		    my($r) = @_;
    		    eval q( &mfspr32($r));
		}' unless defined(&mfspr);
		eval 'sub mtspr {
		    my($r,$v) = @_;
    		    eval q( &mtspr32($r,$v));
		}' unless defined(&mtspr);
	    }
	}
    }
    eval 'sub SPR_XER () {0x1;}' unless defined(&SPR_XER);
    eval 'sub SPR_LR () {0x8;}' unless defined(&SPR_LR);
    eval 'sub SPR_CTR () {0x9;}' unless defined(&SPR_CTR);
    eval 'sub SPR_DEC () {0x16;}' unless defined(&SPR_DEC);
    eval 'sub SPR_SRR0 () {0x1a;}' unless defined(&SPR_SRR0);
    eval 'sub SPR_SRR1 () {0x1b;}' unless defined(&SPR_SRR1);
    eval 'sub SPR_SPRG0 () {0x110;}' unless defined(&SPR_SPRG0);
    eval 'sub SPR_SPRG1 () {0x111;}' unless defined(&SPR_SPRG1);
    eval 'sub SPR_SPRG2 () {0x112;}' unless defined(&SPR_SPRG2);
    eval 'sub SPR_SPRG3 () {0x113;}' unless defined(&SPR_SPRG3);
    eval 'sub SPR_SPRG4 () {0x114;}' unless defined(&SPR_SPRG4);
    eval 'sub SPR_SPRG5 () {0x115;}' unless defined(&SPR_SPRG5);
    eval 'sub SPR_SPRG6 () {0x116;}' unless defined(&SPR_SPRG6);
    eval 'sub SPR_SPRG7 () {0x117;}' unless defined(&SPR_SPRG7);
    eval 'sub SPR_TBL () {0x11c;}' unless defined(&SPR_TBL);
    eval 'sub SPR_TBU () {0x11d;}' unless defined(&SPR_TBU);
    eval 'sub SPR_PVR () {0x11f;}' unless defined(&SPR_PVR);
    eval 'sub TBR_TBL () {0x10c;}' unless defined(&TBR_TBL);
    eval 'sub TBR_TBU () {0x10d;}' unless defined(&TBR_TBU);
}
1;
